﻿CyrillicChatFilter = {}

CyrillicChatFilter.name = "CyrillicChatFilter" 
CyrillicChatFilter.version = 1.4
CyrillicChatFilter.author = "Xerton"

CyrillicChatFilter.Default = {
	Guild1 = true,
	Guild2 = true,
	Guild3 = true,
	Guild4 = true,
	Guild5 = true,
	
	Officer1 = false,
	Officer2 = false,
	Officer3 = false,
	Officer4 = false,
	Officer5 = false,
	
	Say = true,
	
	Yell = true,
	
	Zone = true,
	
	Whisper = false,
	
	Emote = true,
	
	Group = false
}

function CyrillicChatFilter.SaveSetting(channel, bool)

	if channel == "guild1" then CyrillicChatFilter.savedVariables.Guild1 = bool
	elseif channel == "guild2" then CyrillicChatFilter.savedVariables.Guild2 = bool
	elseif channel == "guild3" then CyrillicChatFilter.savedVariables.Guild3 = bool
	elseif channel == "guild4" then CyrillicChatFilter.savedVariables.Guild4 = bool
	elseif channel == "guild5" then CyrillicChatFilter.savedVariables.Guild5 = bool
	elseif channel == "officer1" then CyrillicChatFilter.savedVariables.Officer1 = bool
	elseif channel == "officer2" then CyrillicChatFilter.savedVariables.Officer2 = bool
	elseif channel == "officer3" then CyrillicChatFilter.savedVariables.Officer3 = bool
	elseif channel == "officer4" then CyrillicChatFilter.savedVariables.Officer4 = bool
	elseif channel == "officer5" then CyrillicChatFilter.savedVariables.Officer5 = bool
	elseif channel == "say" then CyrillicChatFilter.savedVariables.Say = bool
	elseif channel == "yell" then CyrillicChatFilter.savedVariables.Yell = bool
	elseif channel == "zone" then CyrillicChatFilter.savedVariables.Zone = bool
	elseif channel == "tell" then CyrillicChatFilter.savedVariables.Whisper = bool
	elseif channel == "emote" then CyrillicChatFilter.savedVariables.Emote = bool
	elseif channel == "group" then CyrillicChatFilter.savedVariables.Group = bool
	end

end

function changeChannelFilter(channel)
	local bool, status
	
	if channel == "guild1" then bool = CyrillicChatFilter.savedVariables.Guild1
	elseif channel == "guild2" then bool =  CyrillicChatFilter.savedVariables.Guild2
	elseif channel == "guild3" then bool = CyrillicChatFilter.savedVariables.Guild3
	elseif channel == "guild4" then bool = CyrillicChatFilter.savedVariables.Guild4
	elseif channel == "guild5" then bool = CyrillicChatFilter.savedVariables.Guild5
	elseif channel == "officer1" then bool = CyrillicChatFilter.savedVariables.Officer1
	elseif channel == "officer2" then bool = CyrillicChatFilter.savedVariables.Officer2
	elseif channel == "officer3" then bool = CyrillicChatFilter.savedVariables.Officer3
	elseif channel == "officer4" then bool = CyrillicChatFilter.savedVariables.Officer4
	elseif channel == "officer5" then bool = CyrillicChatFilter.savedVariables.Officer5
	elseif channel == "say" then bool = CyrillicChatFilter.savedVariables.Say
	elseif channel == "yell" then bool = CyrillicChatFilter.savedVariables.Yell
	elseif channel == "zone" then bool = CyrillicChatFilter.savedVariables.Zone
	elseif channel == "tell" then bool = CyrillicChatFilter.savedVariables.Whisper
	elseif channel == "emote" then bool = CyrillicChatFilter.savedVariables.Emote
	elseif channel == "group" then bool = CyrillicChatFilter.savedVariables.Group
	end
	
	bool = not bool
	
	if bool then status = " will now be filtered"
	else status = " will no longer be filtered"
	end
	
	CHAT_SYSTEM:AddMessage(zo_strformat(channel .. status))
	
	CyrillicChatFilter.SaveSetting(channel, bool)
end

function printStatus()
	CHAT_SYSTEM:AddMessage(zo_strformat("The following chat channels are being filtered:"))
	if CyrillicChatFilter.savedVariables.Guild1 then
		CHAT_SYSTEM:AddMessage(zo_strformat("guild1"))
	end
	if CyrillicChatFilter.savedVariables.Guild2 then
		CHAT_SYSTEM:AddMessage(zo_strformat("guild2"))
	end
	if CyrillicChatFilter.savedVariables.Guild3 then
		CHAT_SYSTEM:AddMessage(zo_strformat("guild3"))
	end
	if CyrillicChatFilter.savedVariables.Guild4 then
		CHAT_SYSTEM:AddMessage(zo_strformat("guild4"))
	end
	if CyrillicChatFilter.savedVariables.Guild5 then
		CHAT_SYSTEM:AddMessage(zo_strformat("guild5"))
	end
	
	if CyrillicChatFilter.savedVariables.Officer1 then
		CHAT_SYSTEM:AddMessage(zo_strformat("officer1"))
	end
	if CyrillicChatFilter.savedVariables.Officer2 then
		CHAT_SYSTEM:AddMessage(zo_strformat("officer2"))
	end
	if CyrillicChatFilter.savedVariables.Officer3 then
		CHAT_SYSTEM:AddMessage(zo_strformat("officer3"))
	end
	if CyrillicChatFilter.savedVariables.Officer4 then
		CHAT_SYSTEM:AddMessage(zo_strformat("officer4"))
	end
	if CyrillicChatFilter.savedVariables.Officer5 then
		CHAT_SYSTEM:AddMessage(zo_strformat("officer5"))
	end
	
	if CyrillicChatFilter.savedVariables.Say then
		CHAT_SYSTEM:AddMessage(zo_strformat("say"))
	end
	if CyrillicChatFilter.savedVariables.Yell then
		CHAT_SYSTEM:AddMessage(zo_strformat("yell"))
	end
	if CyrillicChatFilter.savedVariables.Zone then
		CHAT_SYSTEM:AddMessage(zo_strformat("zone"))
	end
	if CyrillicChatFilter.savedVariables.Whisper then
		CHAT_SYSTEM:AddMessage(zo_strformat("whisper"))
	end
	if CyrillicChatFilter.savedVariables.Emote then
		CHAT_SYSTEM:AddMessage(zo_strformat("emote"))
	end
	if CyrillicChatFilter.savedVariables.Group then
		CHAT_SYSTEM:AddMessage(zo_strformat("group"))
	end
end

function printHelp()
	local toPrint1, toPrint2
	toPrint1 = "Use '/channel <channelname>' to alter the channel filter state"
	toPrint2 = "Use '/channelstatus' to see the current settings"
	CHAT_SYSTEM:AddMessage(zo_strformat(toPrint1))
	CHAT_SYSTEM:AddMessage(zo_strformat(toPrint2))
end

SLASH_COMMANDS["/channelinfo"] = printHelp
SLASH_COMMANDS["/channel"] = changeChannelFilter
SLASH_COMMANDS["/channelstatus"] = printStatus



function CyrillicChatFilter:IsCyrillicMessage(eventType, ...)
	if eventType ~= EVENT_CHAT_MESSAGE_CHANNEL then 
		return false
	end
	
	-- Specify which chat channels should be considered for filtering
	-- current and future default behaviour: Only filter Guild chat, say, yell and zone.
	-- Officers and whisper will not be filtered

	local messageType, fromName, text = ...
	
	local bool = false
	if CyrillicChatFilter.savedVariables.Say then
		bool = messageType == CHAT_CHANNEL_SAY
	end
	
	if CyrillicChatFilter.savedVariables.Emote and not bool then
		bool = messageType == CHAT_CHANNEL_EMOTE
	end
	
	if CyrillicChatFilter.savedVariables.Yell and not bool then
		bool = messageType == CHAT_CHANNEL_YELL
	end
	
	if CyrillicChatFilter.savedVariables.Whisper and not bool then
		bool = messageType == CHAT_CHANNEL_WHISPER
	end
	
	if CyrillicChatFilter.savedVariables.Group and not bool then
		bool = messageType == CHAT_CHANNEL_GROUP
	end
	
	if CyrillicChatFilter.savedVariables.Zone and not bool then
		bool = messageType == CHAT_CHANNEL_ZONE
	end
	
	if CyrillicChatFilter.savedVariables.Zone and not bool then
		bool = messageType == CHAT_CHANNEL_ZONE_LANGUAGE_1
	end
	
	if CyrillicChatFilter.savedVariables.Zone and not bool then
		bool = messageType == CHAT_CHANNEL_ZONE_LANGUAGE_2
	end
	
	if CyrillicChatFilter.savedVariables.Zone and not bool then
		bool = messageType == CHAT_CHANNEL_ZONE_LANGUAGE_3
	end
	
	if CyrillicChatFilter.savedVariables.Officer1 and not bool then
		bool = messageType == CHAT_CHANNEL_OFFICER_1
	end
	
	if CyrillicChatFilter.savedVariables.Officer2 and not bool then
		bool = messageType == CHAT_CHANNEL_OFFICER_2
	end
	
	if CyrillicChatFilter.savedVariables.Officer3 and not bool then
		bool = messageType == CHAT_CHANNEL_OFFICER_3
	end
	
	if CyrillicChatFilter.savedVariables.Officer4 and not bool then
		bool = messageType == CHAT_CHANNEL_OFFICER_4
	end
	
	if CyrillicChatFilter.savedVariables.Officer5 and not bool then
		bool = messageType == CHAT_CHANNEL_OFFICER_5
	end
	
	if CyrillicChatFilter.savedVariables.Guild1 and not bool then
		bool = messageType == CHAT_CHANNEL_GUILD_1
	end
	
	if CyrillicChatFilter.savedVariables.Guild2 and not bool then
		bool = messageType == CHAT_CHANNEL_GUILD_2
	end
	
	if CyrillicChatFilter.savedVariables.Guild3 and not bool then
		bool = messageType == CHAT_CHANNEL_GUILD_3
	end
	
	if CyrillicChatFilter.savedVariables.Guild4 and not bool then
		bool = messageType == CHAT_CHANNEL_GUILD_4
	end
	
	if CyrillicChatFilter.savedVariables.Guild5 and not bool then
		bool = messageType == CHAT_CHANNEL_GUILD_5
	end
	
	if not bool then
		return false
	end
	
	fromName = zo_strformat("<<1>>", fromName)
	
	if GetUnitName("player") == fromName or GetDisplayName() == fromName then
		return false
	end
	
	if CyrillicChatFilter.IsCyrillic(text) then
		return true
	else
		return false
	end
	
end

function CyrillicChatFilter.IsCyrillic(message)
-- detect possible cyrillic characters in the message
	if string.find(message, "Б")
		or string.find(message, "б")
		or string.find(message, "Г")
		or string.find(message, "г")
		or string.find(message, "Д")
		or string.find(message, "д")
		or string.find(message, "Ж")
		or string.find(message, "ж")
		or string.find(message, "З")
		or string.find(message, "з")
		or string.find(message, "И")
		or string.find(message, "и")
		or string.find(message, "Й")
		or string.find(message, "й")
		or string.find(message, "К")
		or string.find(message, "к")
		or string.find(message, "Л")
		or string.find(message, "л")
		or string.find(message, "Н")
		or string.find(message, "н")
		or string.find(message, "П")
		or string.find(message, "п")
		or string.find(message, "У")
		or string.find(message, "Ф")
		or string.find(message, "ф")
		or string.find(message, "Ц")
		or string.find(message, "ц")
		or string.find(message, "Ч")
		or string.find(message, "ч")
		or string.find(message, "Ш")
		or string.find(message, "ш")
		or string.find(message, "Щ")
		or string.find(message, "щ")
		or string.find(message, "Ъ")
		or string.find(message, "ъ")
		or string.find(message, "Ы")
		or string.find(message, "ы")
		or string.find(message, "Э")
		or string.find(message, "э")
		or string.find(message, "Ю")
		or string.find(message, "ю")
		or string.find(message, "Я")
		or string.find(message, "я")
		or string.find(message, "Ђ")
		or string.find(message, "ђ")
		or string.find(message, "Ѓ")
		or string.find(message, "ѓ")
		or string.find(message, "Є")
		or string.find(message, "є")
		or string.find(message, "Љ")
		or string.find(message, "љ")
		or string.find(message, "Њ")
		or string.find(message, "њ")
		or string.find(message, "Ћ")
		or string.find(message, "ћ")
		or string.find(message, "Ќ")
		or string.find(message, "ќ")
		or string.find(message, "Ѝ")
		or string.find(message, "ѝ")
		or string.find(message, "Ў")
		or string.find(message, "ў")
		or string.find(message, "Џ")
		or string.find(message, "џ")
			then
				return true
		else
			return false
	end
end

function CyrillicChatFilter.OnChatEvent(control, ...)
	if CyrillicChatFilter:IsCyrillicMessage(...) then
		-- the message contained cyrillic characters,
		-- so it will be filtered out
		return
	end
	
	-- the message did not contain cyrillic characters,
	-- so it will not be filtered out
	CyrillicChatFilter.OnChatEventOrg(control, ...)
end

function CyrillicChatFilter.CreateMenu()

	local LAM = LibStub:GetLibrary("LibAddonMenu-2.0")
	
	local panelData = {
		type = "panel",
		name = CyrillicChatFilter.name,
		displayName = name,
		author = CyrillicChatFilter.author,
		version = CyrillicChatFilter.version,
	}
	
	LAM:RegisterAddonPanel("CyrillicChatFilter_OptionsPanel", panelData)
	
	local optionsData = {
		
		{--header
			type = "header",
			name = "Filter Settings for each Channel"
		},
		
		-- guild chat
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Guild1 be filtered by this addon?",
			name = "Filter Guild1",
			getFunc = function() return CyrillicChatFilter.savedVariables.Guild1 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("guild1", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Guild2 be filtered by this addon?",
			name = "Filter Guild2",
			getFunc = function() return CyrillicChatFilter.savedVariables.Guild2 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("guild2", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Guild3 be filtered by this addon?",
			name = "Filter Guild3",
			getFunc = function() return CyrillicChatFilter.savedVariables.Guild3 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("guild3", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Guild4 be filtered by this addon?",
			name = "Filter Guild4",
			getFunc = function() return CyrillicChatFilter.savedVariables.Guild4 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("guild4", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Guild5 be filtered by this addon?",
			name = "Filter Guild5",
			getFunc = function() return CyrillicChatFilter.savedVariables.Guild5 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("guild5", bool) end
		},
		
		-- officer chat
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Officer1 be filtered by this addon?",
			name = "Filter Officer1",
			getFunc = function() return CyrillicChatFilter.savedVariables.Officer1 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("officer1", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Officer2 be filtered by this addon?",
			name = "Filter Officer2",
			getFunc = function() return CyrillicChatFilter.savedVariables.Officer2 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("officer2", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Officer3 be filtered by this addon?",
			name = "Filter Officer3",
			getFunc = function() return CyrillicChatFilter.savedVariables.Officer3 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("officer3", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Officer4 be filtered by this addon?",
			name = "Filter Officer4",
			getFunc = function() return CyrillicChatFilter.savedVariables.Officer4 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("officer4", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the chat of Officer5 be filtered by this addon?",
			name = "Filter Officer5",
			getFunc = function() return CyrillicChatFilter.savedVariables.Officer5 end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("officer5", bool) end
		},
		
		-- rest
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the 'say' chat be filtered by this addon?",
			name = "Filter 'say'",
			getFunc = function() return CyrillicChatFilter.savedVariables.Say end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("say", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the 'yell' chat be filtered by this addon?",
			name = "Filter 'yell'",
			getFunc = function() return CyrillicChatFilter.savedVariables.Yell end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("yell", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the 'zone' chat be filtered by this addon?",
			name = "Filter 'zone'",
			getFunc = function() return CyrillicChatFilter.savedVariables.Zone end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("zone", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the 'tell'/'whisper' chat be filtered by this addon?",
			name = "Filter 'tell'/'whisper'",
			getFunc = function() return CyrillicChatFilter.savedVariables.Whisper end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("tell", bool) end
		},
		
		{--checkbox
			type = "checkbox",
			tooltip = "Should the 'emote' chat be filtered by this addon?",
			name = "Filter 'emote'",
			getFunc = function() return CyrillicChatFilter.savedVariables.Emote end,
			setFunc = function(bool) CyrillicChatFilter.SaveSetting("emote", bool) end
		},
	}
	
	LAM:RegisterOptionControls("CyrillicChatFilter_OptionsPanel", optionsData)

end

function CyrillicChatFilter:Initialize()
	
	CyrillicChatFilter.savedVariables = ZO_SavedVars:NewAccountWide("CCFSettings", CyrillicChatFilter.version, nil, CyrillicChatFilter.Default)
	
	CyrillicChatFilter.CreateMenu()
	
	self.OnChatEventOrg = CHAT_SYSTEM.OnChatEvent
	CHAT_SYSTEM.OnChatEvent = CyrillicChatFilter.OnChatEvent
	
end

local function CyrillicChatFilterAddonLoaded(eventType, addonName)
	if addonName ~= "CyrillicChatFilter" then return end
	
	CyrillicChatFilter:Initialize()
end

EVENT_MANAGER:RegisterForEvent("CyrillicChatFilterInitialize", EVENT_ADD_ON_LOADED, CyrillicChatFilterAddonLoaded)